'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 2 May 2003 at 1:44:40 pm'!
Object subclass: #CharacterScanner
	instanceVariableNames: 'destX lastIndex xTable map destY stopConditions text textStyle alignment leftMargin rightMargin font line runStopIndex spaceCount spaceWidth emphasisCode kern indentationLevel wantsColumnBreaks advanceTable '
	classVariableNames: 'DefaultStopConditions '
	poolDictionaries: 'TextConstants '
	category: 'Graphics-Text'!
Object subclass: #FT2BBox
	instanceVariableNames: 'xMin yMin xMax yMax '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2Bitmap
	instanceVariableNames: 'rows width pitch numGrays pixelMode paletteMode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2CharMap
	instanceVariableNames: 'handle encoding platformId encodingId '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Error subclass: #FT2Error
	instanceVariableNames: 'code '
	classVariableNames: 'ErrorCodes '
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2Face
	instanceVariableNames: 'handle numFaces faceIndex faceFlags styleFlags numGlyphs familyName styleName numFixedSizes numCharmaps scalableInfo size charmap glyph glyphFlags '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
AbstractFont subclass: #FT2Font
	instanceVariableNames: 'xTable name offsetTable advanceTable glyphs ascent descent pointSize characterToGlyphMap '
	classVariableNames: 'DefaultStringScanner '
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2Glyph
	instanceVariableNames: 'advance offset form '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2GlyphSlot
	instanceVariableNames: 'handle flags format linearHorizontalAdvance linearVerticalAdvace advanceX advanceY bitmapLeft bitmapTop bitmap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2Interface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
TestInterpreterPlugin subclass: #FT2Plugin
	instanceVariableNames: 'library errorCode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2ScalableFaceInfo
	instanceVariableNames: 'bbox unitsPerEm ascender descender height maxAdvanceWidth maxAdvanceHeigth underlinePosition underlineThickness '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2SizeMetrics
	instanceVariableNames: 'xppem yppem xScale yScale ascender descender height maxAdvance '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!
Object subclass: #FT2Version
	instanceVariableNames: 'major minor apatch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FT2-Plugin'!

!AbstractFont methodsFor: 'accessing' stamp: 'AvE 3/4/2003 18:11'!
advanceTable
	^ nil! !

!AbstractFont methodsFor: 'accessing' stamp: 'AvE 3/5/2003 17:30'!
textStyle
	^ Utilities actualTextStyles detect:
		[:aStyle | aStyle fontArray includes: self] ifNone: [nil]! !


!BitBlt methodsFor: 'copying' stamp: 'AvE 3/5/2003 16:38'!
displayFT2String: aString from: startIndex to: stopIndex at: aPoint strikeFont: font kern: kernDelta

	destY _ aPoint y.
	destX _ aPoint x. 

	"the following are not really needed, but theBitBlt primitive will fail if not set"
	sourceX ifNil: [sourceX _ 100].
	width ifNil: [width _ 100].
	^self primDisplayFT2String: aString from: startIndex to: stopIndex
			map: font characterToGlyphMap aTable: font advanceTable oTable: font offsetTable xTable: font xTable
			kern: kernDelta.! !

!BitBlt methodsFor: 'private' stamp: 'AvE 3/13/2003 16:42'!
installFT2Font: aStrikeFont foregroundColor: foregroundColor backgroundColor: backgroundColor
	aStrikeFont glyphs depth = 1 ifTrue:[^ self installStrikeFont: aStrikeFont foregroundColor: foregroundColor backgroundColor: backgroundColor ].
	sourceForm _ aStrikeFont glyphs.
	combinationRule _ 34.
	sourceY _ 0.
	height _ aStrikeFont height.
	self fillColor: (foregroundColor bitPatternForDepth: 32).
! !

!BitBlt methodsFor: 'private' stamp: 'AvE 3/5/2003 16:10'!
primDisplayFT2String: aString from: startIndex to: stopIndex map: glyphMap aTable: aTable oTable: offsetTable xTable: xTable kern: kernDelta
	| ascii glyph |
	<primitive:'primitiveDisplayFT2String' module:'BitBltPlugin'>
	startIndex to: stopIndex do:[:charIndex|
		ascii _ (aString at: charIndex) asciiValue.
		glyph _ glyphMap at: ascii + 1.
		sourceX _ xTable at: glyph + 1.
		width _ (xTable at: glyph + 2) - sourceX.
		destX _ destX + (offsetTable at: glyph + 1).
		self copyBits.
		destX _ destX - (offsetTable at: glyph + 1).
		destX _ destX + (aTable at: glyph + 1)  + kernDelta.
	].! !


!BitBltSimulation methodsFor: 'setup' stamp: 'AvE 3/4/2003 18:00'!
tryCopyingBitsQuickly
	"Shortcut for stuff that's being run from the balloon engine.
	Since we do this at each scan line we should avoid the expensive 
	setup for source and destination."
	self inline: true.
	"We need a source."
	noSource ifTrue:[^false].
	"We handle only combinationRule 34"
	(combinationRule = 34) ifFalse:[^false].
	"We handle only sourceDepth 32 or 8 for alpha mask"
	((sourceDepth = 32) or: [sourceDepth=8]) ifFalse:[^false].
	"We don't handle overlaps"
	(sourceForm = destForm) ifTrue:[^false].
	"We need at least 8bit deep dest forms"
	(destDepth < 8) ifTrue:[^false].
	"If 8bit, then we want a color map"
	(destDepth = 8 and:[(cmFlags bitAnd: ColorMapPresent) = 0]) ifTrue:[^false].
	destDepth = 32 
		ifTrue:[sourceDepth = 8 
					ifTrue:[self alphaMaskBlendBits32] 
					ifFalse:[self alphaSourceBlendBits32]].
	destDepth = 16
		ifTrue:[sourceDepth = 8 
					ifTrue:[self alphaMaskBlendBits16] 
					ifFalse:[self alphaSourceBlendBits16]].
	destDepth = 8
		ifTrue:[sourceDepth = 8 
					ifTrue:[^false] 
					ifFalse:[self alphaSourceBlendBits16]].
	affectedL _ dx.
	affectedR _ dx + bbW.
	affectedT _ dy.
	affectedB _ dy + bbH.
	^true! !

!BitBltSimulation methodsFor: 'inner loop' stamp: 'AvE 3/18/2003 16:22'!
alphaMaskBlendBits16
	"This version assumes 
		combinationRule = 34
		sourcePixSize = 8
		destPixSize = 16
		sourceForm ~= destForm.
	Note: The inner loop has been optimized for dealing
		with the special cases of srcAlpha = 0.0 and srcAlpha = 1.0 
	"
	| srcIndex dstIndex sourceWord srcAlpha destWord deltaX deltaY srcY dstY halftoneWord srcShift srcMask dstShift mask3 ditherBase ditherIndex dstMask ditherThreshold halftoneAlpha |
	self inline: false. "This particular method should be optimized in itself"

	"Give the compile a couple of hints"
	self var: #sourceWord declareC:'register int sourceWord'.
	self var: #deltaX declareC:'register int deltaX'.

	"The following should be declared as pointers so the compiler will
	notice that they're used for accessing memory locations 
	(good to know on an Intel architecture) but then the increments
	would be different between ST code and C code so must hope the
	compiler notices what happens (MS Visual C does)"
	self var: #srcIndex declareC:'register int srcIndex'.
	self var: #dstIndex declareC:'register int dstIndex'.

	deltaY _ bbH + 1. "So we can pre-decrement"
	srcY _ sy.
	dstY _ dy.

	mask1 _ ((sx bitAnd: 3) * 8).
	sourceMSB ifTrue:[mask1 _ 24 - mask1].
	mask2 _ AllOnes bitXor:(16rFF << mask1).

	dstShift _ (dx bitAnd: 1) * 16.
	destMSB ifTrue:[dstShift _ 16 - dstShift].
	mask3 _ 16rFFFF << (16 - dstShift).

	noHalftone
		ifTrue: [halftoneWord _ AllOnes.  halftoneHeight _ 0]
		ifFalse: [halftoneWord _ ((self halftoneAt: 0) bitOr: 16rFF000000).
					 halftoneAlpha _ (((self halftoneAt: 0) bitAnd: 16rFF000000)  >> 24)].
	
	"This is the outer loop"
	[(deltaY _ deltaY - 1) ~= 0] whileTrue:[
		srcIndex _ sourceBits + (srcY * sourcePitch) + (sx // 4 * 4).
		dstIndex _ destBits + (dstY * destPitch) + (dx // 2 * 4).
		deltaX _ bbW + 1. "So we can pre-decrement"

		ditherBase _ (dstY bitAnd: 3) * 4.
		ditherIndex _ (sx bitAnd: 3) - 1. "For pre-increment"

		srcShift _ mask1.
		srcMask _ mask2.

		dstMask _ mask3.
		dstMask = 16rFFFF ifTrue:[dstShift _ 16] ifFalse:[dstShift _ 0].

		"This is the inner loop"
		[(deltaX _ deltaX - 1) ~= 0] whileTrue:[
			ditherThreshold _ ditherMatrix4x4 at: ditherBase + (ditherIndex _ ditherIndex + 1 bitAnd: 3).
			sourceWord _ self srcLongAt: srcIndex.
			sourceWord _ sourceWord bitAnd: srcMask bitInvert32.
			sourceWord _ sourceWord >> srcShift.
			sourceWord _ halftoneAlpha * sourceWord //  16rFF.
			sourceWord _ (sourceWord << 24) bitOr: 16rFFFFFF.
			sourceWord _ sourceWord bitAnd: halftoneWord.
			srcAlpha _ sourceWord >> 24.
			srcAlpha > 0 ifTrue:[
				srcAlpha < 255 ifTrue:[
						destWord _ self dstLongAt: dstIndex.
						destWord _ destWord bitAnd: dstMask bitInvert32.
						destWord _ destWord >> dstShift.
						"Expand from 16 to 32 bit by adding zero bits"
						destWord _ (((destWord bitAnd: 16r7C00) bitShift: 9) bitOr:
									((destWord bitAnd: 16r3E0) bitShift: 6)) bitOr:
								(((destWord bitAnd: 16r1F) bitShift: 3) bitOr:
									16rFF000000).
						sourceWord _ self alphaBlend: sourceWord with: destWord.
					].
					"And dither"
					sourceWord _ self dither32To16: sourceWord threshold: ditherThreshold.
					sourceWord = 0 ifTrue:[sourceWord _ 1].
					sourceWord _ sourceWord << dstShift.
					"Store back"
					self dstLongAt: dstIndex put: sourceWord mask: dstMask.
				].
			sourceMSB ifTrue:[
				srcShift = 0 
					ifTrue:[srcIndex _ srcIndex + 4.
							srcShift _ 24.
							srcMask _ 16r00FFFFFF]
					ifFalse:[srcShift _ srcShift - 8.
							srcMask _ (srcMask >> 8) bitOr: 16rFF000000].
			] ifFalse:[
				srcShift = 32
					ifTrue:[srcIndex _ srcIndex + 4.
							srcShift _ 0.
							srcMask _ 16rFFFFFF00]
					ifFalse:[srcShift _ srcShift + 8.
							srcMask _ srcMask << 8 bitOr: 255].
			].
			destMSB
				ifTrue:[dstShift = 0 ifTrue:[dstIndex _ dstIndex + 4]]
				ifFalse:[dstShift = 0 ifFalse:[dstIndex _ dstIndex + 4]].
			dstShift _ dstShift bitXor: 16. "Toggle between 0 and 16"
			dstMask _ dstMask bitInvert32. "Mask other half word"
			].
		srcY _ srcY + 1.
		dstY _ dstY + 1.
	].! !

!BitBltSimulation methodsFor: 'inner loop' stamp: 'AvE 3/18/2003 16:17'!
alphaMaskBlendBits32
	"This version assumes 
		combinationRule = 34
		sourcePixSize = 8
		destPixSize = 32
		sourceForm ~= destForm.
	Note: The inner loop has been optimized for dealing
		with the special cases of srcAlpha = 0.0 and srcAlpha = 1.0 
	"
	| srcIndex dstIndex sourceWord srcAlpha destWord deltaX deltaY srcY dstY halftoneWord halftoneAlpha srcShift srcMask |
	self inline: false. "This particular method should be optimized in itself"

	"Give the compile a couple of hints"
	self var: #sourceWord declareC:'register int sourceWord'.
	self var: #deltaX declareC:'register int deltaX'.

	"The following should be declared as pointers so the compiler will
	notice that they're used for accessing memory locations 
	(good to know on an Intel architecture) but then the increments
	would be different between ST code and C code so must hope the
	compiler notices what happens (MS Visual C does)"
	self var: #srcIndex declareC:'register int srcIndex'.
	self var: #dstIndex declareC:'register int dstIndex'.

	deltaY _ bbH + 1. "So we can pre-decrement"
	srcY _ sy.
	dstY _ dy.

	mask1 _ ((sx bitAnd: 3) * 8).
	sourceMSB ifTrue:[mask1 _ 24 - mask1].
	mask2 _ AllOnes bitXor:(16rFF << mask1).

	noHalftone
		ifTrue: [halftoneWord _ AllOnes.  halftoneHeight _ 0]
		ifFalse: [halftoneWord _ ((self halftoneAt: 0) bitOr: 16rFF000000).
				 halftoneAlpha _ (((self halftoneAt: 0) bitAnd: 16rFF000000)  >> 24)].
	
	"This is the outer loop"
	[(deltaY _ deltaY - 1) ~= 0] whileTrue:[
		srcIndex _ sourceBits + (srcY * sourcePitch) + (sx // 4 * 4).
		dstIndex _ destBits + (dstY * destPitch) + (dx * 4).
		deltaX _ bbW + 1. "So we can pre-decrement"
		
		srcShift _ mask1.
		srcMask _ mask2.

		"This is the inner loop"
		[(deltaX _ deltaX - 1) ~= 0] whileTrue:[
			sourceWord _ self srcLongAt: srcIndex.
			sourceWord _ sourceWord bitAnd: srcMask bitInvert32.
			sourceWord _ sourceWord >> srcShift.
			sourceWord _ halftoneAlpha * sourceWord //  16rFF.
			sourceWord _ (sourceWord << 24) bitOr: 16rFFFFFF.
			sourceWord _ sourceWord bitAnd: halftoneWord.
			srcAlpha _ sourceWord >> 24.
			srcAlpha > 0 ifTrue:[
				srcAlpha < 255 ifTrue:[
					destWord _ self dstLongAt: dstIndex.
					sourceWord _ self alphaBlend: sourceWord with: destWord.
					].
				self dstLongAt: dstIndex put: sourceWord.
				].
			sourceMSB ifTrue:[
				srcShift = 0 
					ifTrue:[srcIndex _ srcIndex + 4.
							srcShift _ 24.
							srcMask _ 16r00FFFFFF]
					ifFalse:[srcShift _ srcShift - 8.
							srcMask _ (srcMask >> 8) bitOr: 16rFF000000].
			] ifFalse:[
				srcShift = 32
					ifTrue:[srcIndex _ srcIndex + 4.
							srcShift _ 0.
							srcMask _ 16rFFFFFF00]
					ifFalse:[srcShift _ srcShift + 8.
							srcMask _ srcMask << 8 bitOr: 255].
			].
			dstIndex _ dstIndex + 4.	
			].
		srcY _ srcY + 1.
		dstY _ dstY + 1.
	].! !

!BitBltSimulation methodsFor: 'primitives' stamp: 'AvE 8/25/2002 15:39'!
primitiveDisplayFT2String
	| kernDelta xTable glyphMap stopIndex startIndex sourceString bbObj maxGlyph ascii glyphIndex sourcePtr left quickBlt offsetTable offsetX advanceTable advanceX done |
	self export: true.
	self var: #sourcePtr type: 'unsigned char *'.
	interpreterProxy methodArgumentCount = 8
		ifFalse:[^interpreterProxy primitiveFail].
	kernDelta _ interpreterProxy stackIntegerValue: 0.
	xTable _ interpreterProxy stackObjectValue: 1.
	offsetTable _ interpreterProxy stackObjectValue: 2.
	advanceTable _ interpreterProxy stackObjectValue: 3.
	glyphMap _ interpreterProxy stackObjectValue: 4.
	((interpreterProxy fetchClassOf: offsetTable) = interpreterProxy classArray and:[
		(interpreterProxy fetchClassOf: advanceTable) = interpreterProxy classArray])
			ifFalse:[^interpreterProxy primitiveFail].
	((interpreterProxy fetchClassOf: xTable) = interpreterProxy classArray and:[
		(interpreterProxy fetchClassOf: glyphMap) = interpreterProxy classArray])
			ifFalse:[^interpreterProxy primitiveFail].
	(interpreterProxy slotSizeOf: glyphMap) = 256 ifFalse:[^interpreterProxy primitiveFail].
	interpreterProxy failed ifTrue:[^nil].
	maxGlyph _ (interpreterProxy slotSizeOf: xTable) - 2.

	stopIndex _ interpreterProxy stackIntegerValue: 5.
	startIndex _ interpreterProxy stackIntegerValue: 6.
	sourceString _ interpreterProxy stackObjectValue: 7.
	(interpreterProxy isBytes: sourceString) ifFalse:[^interpreterProxy primitiveFail].
	(startIndex > 0 and:[stopIndex > 0 and:[
		stopIndex <= (interpreterProxy byteSizeOf: sourceString)]])
			ifFalse:[^interpreterProxy primitiveFail].

	bbObj _ interpreterProxy stackObjectValue: 8.
	(self loadBitBltFrom: bbObj) ifFalse:[^interpreterProxy primitiveFail].
	(combinationRule = 30 or:[combinationRule = 31]) "needs extra source alpha"
		ifTrue:[^interpreterProxy primitiveFail].
	"See if we can go directly into copyLoopPixMap (usually we can)"
	quickBlt _ destBits ~= 0 "no OS surfaces please"
				and:[sourceBits ~= 0 "and again"
				and:[noSource = false "needs a source"
				and:[sourceForm ~= destForm "no blits onto self"
				and:[(cmFlags ~= 0 
						or:[sourceMSB ~= destMSB 
						or:[sourceDepth ~= destDepth]]) "no point using slower version"
				]]]].
	left _ destX.
	sourcePtr _ interpreterProxy firstIndexableField: sourceString.
	startIndex to: stopIndex do:[:charIndex|
		ascii _ interpreterProxy byteAt: sourcePtr + charIndex - 1.
		glyphIndex _ interpreterProxy fetchInteger: ascii ofObject: glyphMap.
		(glyphIndex < 0 or:[glyphIndex > maxGlyph]) 
			ifTrue:[^interpreterProxy primitiveFail].
		sourceX _ interpreterProxy fetchInteger: glyphIndex ofObject: xTable.
		offsetX _ interpreterProxy fetchInteger: glyphIndex ofObject: offsetTable.
		advanceX _ interpreterProxy fetchInteger: glyphIndex ofObject: advanceTable.
		width _ (interpreterProxy fetchInteger: glyphIndex+1 ofObject: xTable) - sourceX.
		destX _ destX +offsetX.
		interpreterProxy failed ifTrue:[^nil].
		self clipRange.	"Must clip here"
		(bbW > 0 and:[bbH > 0]) ifTrue: [
			 quickBlt ifTrue:[
				done _ self tryCopyingBitsQuickly.
				done ifFalse:[
					self destMaskAndPointerInit.
					self copyLoopPixMap].
				"both, hDir and vDir are known to be > 0"
				affectedL _ dx.
				affectedR _ dx + bbW.
				affectedT _ dy.
				affectedB _ dy + bbH.
			] ifFalse:[self copyBits]].
		interpreterProxy failed ifTrue:[^nil].
		destX _ destX - offsetX.
		destX _ destX + advanceX + kernDelta.
	 ].
	affectedL _ left.
	self showDisplayBits.
	interpreterProxy pop: 8. "pop args, return rcvr"! !


!BitBltSimulation class methodsFor: 'debug' stamp: 'AvE 8/24/2002 21:48'!
alphaMaskDemo
	"self alphaMaskDemo. Display restore"
	| bits source f hf |
	bits _ Color blue bitPatternForDepth: 32.
	source _ Form fromUser asGrayScale.
	f _ Form extent: source extent depth: 8.
	source displayOn: f.
	hf _ bits.
	(BitBlt
		destForm: Display
		sourceForm: f
		halftoneForm: hf
		combinationRule: 34
		destOrigin: 0 @ 0
		sourceOrigin: 0 @ 0
		extent: source extent
		clipRect: source computeBoundingBox) copyBitsSimulated! !


!CharacterScanner methodsFor: 'private' stamp: 'AvE 3/4/2003 18:11'!
setFont
	| priorFont |
	"Set the font and other emphasis."
	priorFont _ font.
	text == nil ifFalse:[
		emphasisCode _ 0.
		kern _ 0.
		indentationLevel _ 0.
		alignment _ textStyle alignment.
		font _ nil.
		(text attributesAt: lastIndex forStyle: textStyle)
			do: [:att | att emphasizeScanner: self]].
	font == nil ifTrue:
		[self setFont: textStyle defaultFontIndex].
	font _ font emphasized: emphasisCode.
	priorFont ifNotNil: [destX _ destX + priorFont descentKern].
	destX _ destX - font descentKern.
	"NOTE: next statement should be removed when clipping works"
	leftMargin ifNotNil: [destX _ destX max: leftMargin].
	kern _ kern - font baseKern.

	"Install various parameters from the font."
	spaceWidth _ font widthOf: Space.
	xTable _ font xTable.
	advanceTable _ font advanceTable.
	map _ font characterToGlyphMap.
	stopConditions _ DefaultStopConditions.! !

!CharacterScanner methodsFor: 'scanning' stamp: 'AvE 3/4/2003 18:13'!
measureString: aString inFont: aFont from: startIndex to: stopIndex
	"WARNING: In order to use this method the receiver has to be set up using #initializeStringMeasurer"
	| oldFont |
	destX _ destY _ lastIndex _ 0.
	xTable _ aFont xTable.
	advanceTable _ aFont advanceTable.
	oldFont _ font.
	font _ aFont.
	map _ aFont characterToGlyphMap.
	self scanCharactersFrom: startIndex to: stopIndex in: aString rightX: 999999 stopConditions: stopConditions kern: 0.
	font _ oldFont.
	^destX! !

!CharacterScanner methodsFor: 'scanning' stamp: 'AvE 3/4/2003 18:03'!
scanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta
	"Primitive. This is the inner loop of text display--but see 
	scanCharactersFrom: to:rightX: which would get the string, 
	stopConditions and displaying from the instance. March through source 
	String from startIndex to stopIndex. If any character is flagged with a 
	non-nil entry in stops, then return the corresponding value. Determine 
	width of each character from xTable, indexed by map. 
	If dextX would exceed rightX, then return stops at: 258. 
	Advance destX by the width of the character. If stopIndex has been
	reached, then return stops at: 257. Optional. 
	See Object documentation whatIsAPrimitive."
	| ascii nextDestX char |
	"<primitive: 103>"
	<primitive: 'primitiveAdvanceScan' module: 'FT2Plugin'>
	lastIndex _ startIndex.
	[lastIndex <= stopIndex]
		whileTrue: 
			[char _ (sourceString at: lastIndex).
			ascii _ char asciiValue + 1.
			(stops at: ascii) == nil ifFalse: [^stops at: ascii].
			"Note: The following is querying the font about the width
			since the primitive may have failed due to a non-trivial
			mapping of characters to glyphs or a non-existing xTable."
			nextDestX _ destX + (font widthOf: char)  .
			nextDestX > rightX ifTrue: [^stops at: CrossedX].
			destX _ nextDestX + kernDelta.
			lastIndex _ lastIndex + 1].
	lastIndex _ stopIndex.
	^stops at: EndOfRun! !


!FT2Bitmap methodsFor: 'accessing' stamp: 'AvE 3/6/2003 17:03'!
depth
	^ pixelMode = 1 ifTrue:[1] ifFalse:[8].! !

!FT2Bitmap methodsFor: 'accessing' stamp: 'AvE 8/11/2002 15:57'!
extent
	^ width@rows.! !

!FT2Bitmap methodsFor: 'accessing' stamp: 'AvE 3/6/2003 16:51'!
numGrays! !


!FT2CharMap methodsFor: 'initialize' stamp: 'AvE 8/4/2002 13:39'!
initialize
	handle := ByteArray new: 4.! !

!FT2CharMap methodsFor: 'initialize' stamp: 'AvE 8/4/2002 13:59'!
load
	<primitive: 'primitiveCharMapInformation' module: 'FT2Plugin'>
	^self primitiveFailed.! !


!FT2CharMap class methodsFor: 'instance creation' stamp: 'AvE 8/4/2002 13:40'!
new
	^ super new initialize! !


!FT2Error class methodsFor: 'as yet unclassified' stamp: 'AvE 10/17/2002 20:30'!
addErrorCode: aCode text: aString
	self errorCodes at: aCode put: aString.! !

!FT2Error class methodsFor: 'as yet unclassified' stamp: 'AvE 10/17/2002 20:31'!
errorCodes
	ErrorCodes isNil ifTrue:[ ErrorCodes := Dictionary new].
	^ ErrorCodes.! !

!FT2Error class methodsFor: 'as yet unclassified' stamp: 'AvE 10/17/2002 20:32'!
initializeErrorCodes
	self addErrorCode: 1 text: 'cannot open resource'.
	self addErrorCode: 2 text: 'unknown file format'.
	self addErrorCode: 3 text: 'broken file'.
	self addErrorCode: 4 text: 'invalid FreeType version'.
	self addErrorCode: 5 text: 'module version is too low'.
	self addErrorCode: 6 text: 'invalid argument'.
	self addErrorCode: 7 text: 'unimplemented feature'.
	self addErrorCode: 16 text: 'invalid glyph index'.
	self addErrorCode: 17 text: 'invalid character code'.
	self addErrorCode: 18 text: 'unsupported glyph image format'.
	self addErrorCode: 19 text: 'cannot render this glyph format'.
	self addErrorCode: 20 text: 'invalid outline'.
	self addErrorCode: 21 text: 'invalid composite glyph'.
	self addErrorCode: 22 text: 'too many hints'.
	self addErrorCode: 23 text: 'invalid pixel size'.
	self addErrorCode: 32 text: 'invalid object handle'.
	self addErrorCode: 33 text: 'invalid library handle'.
	self addErrorCode: 34 text: 'invalid module handle'.
	self addErrorCode: 35 text: 'invalid face handle'.
	self addErrorCode: 36 text: 'invalid size handle'.
	self addErrorCode: 37 text: 'invalid glyph slot handle'.
	self addErrorCode: 38 text: 'invalid charmap handle'.
	self addErrorCode: 39 text: 'invalid cache manager handle'.
	self addErrorCode: 40 text: 'invalid stream handle'.
	self addErrorCode: 48 text: 'too many modules'.
	self addErrorCode: 49 text: 'too many extensions'.
	self addErrorCode: 64 text: 'out of memory'.
	self addErrorCode: 65 text: 'unlisted object'.
	self addErrorCode: 81 text: 'cannot open stream'.
	self addErrorCode: 82 text: 'invalid stream seek'.
	self addErrorCode: 83 text: 'invalid stream skip'.
	self addErrorCode: 84 text: 'invalid stream read'.
	self addErrorCode: 85 text: 'invalid stream operation'.
	self addErrorCode: 86 text: 'invalid frame operation'.
	self addErrorCode: 87 text: 'nested frame access'.
	self addErrorCode: 88 text: 'invalid frame read'.
	self addErrorCode: 96 text: 'raster uninitialized'.
	self addErrorCode: 97 text: 'raster corrupted'.
	self addErrorCode: 98 text: 'raster overflow'.
	self addErrorCode: 99 text: 'negative height while rastering'.
	self addErrorCode: 112 text: 'too many registered caches'.
	self addErrorCode: 128 text: 'invalid opcode'.
	self addErrorCode: 129 text: 'too few arguments'.
	self addErrorCode: 130 text: 'stack overflow'.
	self addErrorCode: 131 text: 'code overflow'.
	self addErrorCode: 132 text: 'bad argument'.
	self addErrorCode: 133 text: 'division by zero'.
	self addErrorCode: 134 text: 'invalid reference'.
	self addErrorCode: 135 text: 'found debug opcode'.
	self addErrorCode: 136 text: 'found ENDF opcode in execution stream'.
	self addErrorCode: 137 text: 'nested DEFS'.
	self addErrorCode: 138 text: 'invalid code range'.
	self addErrorCode: 139 text: 'execution context too long'.
	self addErrorCode: 140 text: 'too many function definitions'.
	self addErrorCode: 141 text: 'too many instruction definitions'.
	self addErrorCode: 142 text: 'SFNT font table missing'.
	self addErrorCode: 143 text: 'horizontal header (hhea) table missing'.
	self addErrorCode: 144 text: 'locations (loca) table missing'.
	self addErrorCode: 145 text: 'name table missing'.
	self addErrorCode: 146 text: 'character map (cmap) table missing'.
	self addErrorCode: 147 text: 'horizontal metrics (hmtx) table missing'.
	self addErrorCode: 148 text: 'PostScript (post) table missing'.
	self addErrorCode: 149 text: 'invalid horizontal metrics'.
	self addErrorCode: 150 text: 'invalid character map (cmap) format'.
	self addErrorCode: 151 text: 'invalid ppem value'.
	self addErrorCode: 152 text: 'invalid vertical metrics'.
	self addErrorCode: 153 text: 'could not find context'.
	self addErrorCode: 154 text: 'invalid PostScript (post) table format'.
	self addErrorCode: 155 text: 'invalid PostScript (post) table'.
	self addErrorCode: 160 text: 'opcode syntax error'.
	self addErrorCode: 161 text: 'argument stack underflow'! !


!FT2Face methodsFor: 'initialize' stamp: 'AvE 8/4/2002 14:36'!
initialize
	scalableInfo := FT2ScalableFaceInfo new.! !

!FT2Face methodsFor: 'initialize' stamp: 'AvE 8/4/2002 12:40'!
load
	<primitive: 'primitiveFaceInformation' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'initialize' stamp: 'AvE 8/4/2002 12:39'!
setHandle: aFaceHandle
	handle := aFaceHandle.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:48'!
antialiasedGlyphs
	^ self glyphs: (16r4)! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 16:23'!
charMaps
		| maps |
	maps := Array new: numCharmaps.
		1 to: maps size do:[:i | maps at: i put: (FT2CharMap new)].
		self charMaps: maps.
		^ maps.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 13:05'!
charMaps: anArray
	<primitive: 'primitiveFaceCharMaps' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 2/27/2003 14:08'!
close
	handle isNil ifFalse:[ FT2Interface new doneFace: handle].
	handle := nil.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/10/2002 21:38'!
glyphIndexOf: charInder
	<primitive: 'primitiveGetCharIndex' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/10/2002 21:41'!
glyphIndexOfCharNamed: aString
	<primitive: 'primitiveGetNamedIndex' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/10/2002 21:40'!
glyphIndexOfCharValue: charIndex
	<primitive: 'primitiveGetCharIndex' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:47'!
glyphs
	^ self glyphs: (16r4 bitOr: 16r1000)! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:49'!
glyphs: anInteger
	| set idx |
	set := Array new: 255.
	1 to: 255 do:[:i  |
		idx := self glyphIndexOfCharValue: i.
		idx = 0 ifFalse:[ (self loadGlyphAt: idx flags: anInteger).
			 set at: i put: glyph asGlyph].
		].
	^ set.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 10/20/2002 14:09'!
handle
	^ handle! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 16:24'!
loadCharMap: aFT2CharMap
	<primitive: 'primitiveGetFaceCharMap' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 16:21'!
loadFaceSize: aFT2SizeMetrics
	<primitive: 'primitiveGetFaceSize' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:45'!
loadGlyphAt: index
	glyph isNil ifTrue:[ glyph :=  FT2GlyphSlot new].
	self primLoadGlyphAt: index flags: (16r4 bitOr: 16r1000).
	self loadGlyphSlot: glyph.
	glyph load.
	^ glyph.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:46'!
loadGlyphAt: index flags: anInteger
	glyph isNil ifTrue:[ glyph :=  FT2GlyphSlot new].
	self primLoadGlyphAt: index flags: anInteger.
	self loadGlyphSlot: glyph.
	glyph load.
	^ glyph.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 16:26'!
loadGlyphSlot: aFT2GlyphSlot
	<primitive: 'primitiveGetFaceGlyphSlot' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 16:15'!
loadScalableInfo
	self loadScalableInfo: scalableInfo.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 16:14'!
loadScalableInfo: anInfo
	<primitive: 'primitiveGetScalableFaceInformation' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:48'!
monoGlyphs
	^ self glyphs: (16r4 bitOr: 16r1000)! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 10/20/2002 14:13'!
name
	^ familyName	! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:45'!
primLoadGlyphAt: index flags: flags
	<primitive: 'primitiveLoadGlyph' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/10/2002 22:08'!
setPixelWidth: x height:y
	<primitive: 'primitiveSetPixelSizes' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Face methodsFor: 'as yet unclassified' stamp: 'AvE 8/22/2002 21:00'!
sizeMetrics
	size := FT2SizeMetrics new.
	self loadFaceSize: size.
	^ size.! !

!FT2Face methodsFor: 'converting' stamp: 'AvE 3/13/2003 16:49'!
asFont
	| font metrics |
	metrics := self sizeMetrics.
	font := FT2Font new setFamilyName: familyName,' ',styleName size:  metrics ppem y.
	font setGlyphs: self antialiasedGlyphs metrics: metrics.
	^ font.! !

!FT2Face methodsFor: 'converting' stamp: 'AvE 5/2/2003 13:27'!
asFontArray: anArray antialiased: antialiased 
	^ anArray
		collect: [:each | 
			self setPixelWidth: each height: 0.
			antialiased
				ifTrue: [self asFont]
				ifFalse: [self asMonoFont]]! !

!FT2Face methodsFor: 'converting' stamp: 'AvE 3/13/2003 16:48'!
asMonoFont
	| font metrics |
	metrics := self sizeMetrics.
	font := FT2Font new setFamilyName: familyName,' ',styleName size:  metrics ppem y.
	font setGlyphs: self monoGlyphs metrics: metrics.
	^ font.! !


!FT2Face class methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 14:19'!
new
	^ super new initialize! !


!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 8/25/2002 14:37'!
advanceTable
	^ advanceTable.! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 3/5/2003 15:27'!
ascent
	^ ascent! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 10/17/2002 19:46'!
baseKern
	^ 0! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 3/5/2003 15:27'!
descent
	^ descent! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 10/17/2002 19:46'!
descentKern
	^ 0! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 8/25/2002 14:29'!
displayString: aString on: aBitBlt from: startIndex to: stopIndex at: aPoint kern: kernDelta
	"Draw the given string from startIndex to stopIndex 
	at aPoint on the (already prepared) BitBlt."
	aBitBlt displayFT2String: aString 
			from: startIndex 
			to: stopIndex 
			at: aPoint 
			strikeFont: self
			kern: kernDelta.! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 3/5/2003 17:27'!
emphasized: aCode
	^ self.! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 3/5/2003 15:28'!
glyphs
	^ glyphs! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 3/5/2003 15:27'!
height
	"Answer the height of the receiver, total of maximum extents of 
	characters above and below the baseline."

	^self ascent + self descent! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 8/11/2002 18:01'!
installOn: aDisplayContext foregroundColor: foregroundColor backgroundColor: backgroundColor
	^aDisplayContext 
		installFT2Font: self
		foregroundColor: foregroundColor 
		backgroundColor: backgroundColor! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 8/25/2002 14:29'!
offsetTable
	^ offsetTable.! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 8/11/2002 17:37'!
setFamilyName: aString size: aNumber
	name := aString.
	pointSize := aNumber.! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 3/13/2003 16:43'!
setGlyphs: glyphColl metrics: metrics
	| offset height maxWidth totalWidth i depth |
	characterToGlyphMap _ Array new: 256 withAll: 0.
	maxWidth :=0. 
	ascent := metrics scaledAscender.
	descent := metrics scaledDescender negated.
	totalWidth := 0.
	depth := (glyphColl detect:[:any | any isNil not]) form depth.
	(glyphColl reject: [:any | any isNil]) do:[:each |
		maxWidth:= each form width max: maxWidth.
	    totalWidth := each form width + totalWidth.].
	totalWidth := totalWidth + maxWidth.
	height := metrics scaledHeight.
	glyphs := Form extent: (totalWidth) @ height depth: depth.
	xTable := OrderedCollection new.
	offsetTable:= OrderedCollection new.
	advanceTable:= OrderedCollection new.
	xTable add: 0.
	offsetTable add:0.
	advanceTable add:0. 
	offset := maxWidth@ascent.
	i := 1.
	glyphColl keysAndValuesDo:[:ch :each | .
		each isNil ifTrue:[characterToGlyphMap at: ch + 1 put: 0. ] 
				   ifFalse:[
						characterToGlyphMap at: ch + 1 put: i.
						i := i + 1.
						xTable add: offset x.
						   (BitBlt toForm: glyphs) copyForm: each form to: offset + (0@ (each offset y)) rule: Form over.
						   offsetTable add: each offset x.
						   advanceTable add: each advance x.
					 	   offset:= offset +  (each form width@0)]].
	offsetTable := offsetTable asArray.
	advanceTable := advanceTable asArray.
	xTable := xTable asArray.
	^ self.! !

!FT2Font methodsFor: 'as yet unclassified' stamp: 'AvE 3/5/2003 15:26'!
xTable
	^ xTable! !

!FT2Font methodsFor: 'accessing' stamp: 'AvE 3/5/2003 15:30'!
characterToGlyphMap
	^characterToGlyphMap ! !

!FT2Font methodsFor: 'accessing' stamp: 'AvE 3/5/2003 17:28'!
familyName
	^ name! !

!FT2Font methodsFor: 'accessing' stamp: 'AvE 3/5/2003 17:23'!
pointSize
	^ pointSize.! !

!FT2Font methodsFor: 'measuring' stamp: 'AvE 3/5/2003 16:41'!
widthOf: aCharacter 
	"Answer the width of the argument as a character in the receiver."

	| ascii i |
	ascii _ aCharacter asciiValue.
	i := characterToGlyphMap at: ascii.
	^ (advanceTable at: i + 1)
! !

!FT2Font methodsFor: 'measuring' stamp: 'AvE 3/5/2003 15:52'!
widthOfString: aString from: firstIndex to: lastIndex
	"Measure the length of the given string between start and stop index"
	DefaultStringScanner 
		ifNil:[DefaultStringScanner _ CharacterScanner new initializeStringMeasurer].
	^DefaultStringScanner measureString: aString inFont: self from: firstIndex to: lastIndex
! !


!FT2Font class methodsFor: 'as yet unclassified' stamp: 'AvE 5/2/2003 13:22'!
textStyleFromFileNamed: aString sizes: anArray
	| plugin face fonts style |
	plugin := FT2Interface new.
	face := FT2Face  new.
	face setHandle: (plugin  newFace: aString at: 0).
	face load.
	fonts := anArray collect: [:size | face setPixelWidth: size height: 0.
		face asFont].
	style := TextStyle fontArray: fonts.
	TextConstants at: face name put: style.
	plugin doneFace: face handle.
	^ style.
	! !


!FT2Glyph methodsFor: 'initialize' stamp: 'AvE 2/28/2003 10:30'!
setAdvance: aPoint offset: offsetPoint form: aForm
	advance := aPoint.
	offset := offsetPoint.
	form := aForm.
	Smalltalk isLittleEndian ifTrue:[form swapEndianness].! !

!FT2Glyph methodsFor: 'accessing' stamp: 'AvE 8/11/2002 16:38'!
advance
	^ advance.! !

!FT2Glyph methodsFor: 'accessing' stamp: 'AvE 8/11/2002 16:38'!
form
	^ form.! !

!FT2Glyph methodsFor: 'accessing' stamp: 'AvE 8/11/2002 16:38'!
offset
	^ offset.! !


!FT2GlyphSlot methodsFor: 'initialize' stamp: 'AvE 3/6/2003 17:03'!
bitmapForm
	| bm |
	bm := FT2Bitmap new.
	self loadBitmap: bm.
	"for now assume 256 always!!"
	^  Form extent: bm  extent depth: bm depth bits: self getBitmapBuffer.

	! !

!FT2GlyphSlot methodsFor: 'initialize' stamp: 'AvE 8/10/2002 22:34'!
getBitmapBuffer
	<primitive: 'primitiveGetBitmapBuffer' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2GlyphSlot methodsFor: 'initialize' stamp: 'AvE 8/4/2002 16:01'!
initialize
	handle := ByteArray new: 4.! !

!FT2GlyphSlot methodsFor: 'initialize' stamp: 'AvE 8/4/2002 17:08'!
load
	<primitive: 'primitiveGlyphSlotInformation' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2GlyphSlot methodsFor: 'initialize' stamp: 'AvE 8/10/2002 21:55'!
loadBitmap: aFT2Bitmap
	<primitive: 'primitiveGetBitmap' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2GlyphSlot methodsFor: 'accessing' stamp: 'AvE 8/11/2002 16:34'!
offset
	^ bitmapLeft @ (bitmapTop negated).! !

!FT2GlyphSlot methodsFor: 'accessing' stamp: 'AvE 3/4/2003 10:47'!
scaledAdvance
	^ (advanceX bitShift: -6)
		@ (advanceY bitShift: -6)! !

!FT2GlyphSlot methodsFor: 'accessing' stamp: 'AvE 3/4/2003 10:47'!
scaledAdvance: factor 
	^ (advanceX @ advanceY / factor) asIntegerPoint! !

!FT2GlyphSlot methodsFor: 'converting' stamp: 'AvE 8/11/2002 16:39'!
asGlyph
	^ FT2Glyph new setAdvance: self scaledAdvance offset: self offset form: self bitmapForm.! !


!FT2GlyphSlot class methodsFor: 'as yet unclassified' stamp: 'AvE 8/4/2002 16:01'!
new
	^ super new initialize.! !


!FT2Interface methodsFor: 'primives' stamp: 'AvE 5/2/2003 13:04'!
checkFace: fname
 self newFace: fname at: -1.
	! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 7/31/2002 23:14'!
doneFace: aFaceHandle
	<primitive: 'primitiveDoneFace' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 7/31/2002 22:58'!
errorCode
	<primitive: 'primitiveErrorCode' module: 'FT2Plugin'>
	^self primitiveFailed.
! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 5/2/2003 13:27'!
fontArrayFromFile: aString sizes: anArray antialiased: antialiased 
	^ self
		openFontFile: aString
		do: [:face | face asFontArray: anArray antialiased: antialiased]! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 5/2/2003 12:56'!
newFace: aString at: index
	<primitive: 'primitiveNewFaceAt' module: 'FT2Plugin'>
	^self primitiveFailed.! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 5/2/2003 12:57'!
openFace: fname
	| handle |
	handle := self newFace: fname at: 2.
	^ FT2Face new setHandle: handle; load; yourself.! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 5/2/2003 13:30'!
textStyleFromFile: aString sizes: anArray 
	^ self
		textStyleFromFile: aString sizes: anArray antialiased: true! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 5/2/2003 13:29'!
textStyleFromFile: aString sizes: anArray antialiased: antialiased 
	^ self
		openFontFile: aString
		do: [:face | 
			| fonts style | 
			fonts _ face asFontArray: anArray antialiased: antialiased.
			style _ TextStyle fontArray: fonts.
			TextConstants at: face name put: style.
			style]! !

!FT2Interface methodsFor: 'primives' stamp: 'AvE 8/2/2002 14:03'!
version
	^ (FT2Version new) load; yourself.! !

!FT2Interface methodsFor: 'font-loading' stamp: 'AvE 3/18/2003 13:33'!
fontArrayFromFile: aString sizes: anArray 
	^ self fontArrayFromFile: aString sizes: anArray antialiased: true.! !

!FT2Interface methodsFor: 'font-loading' stamp: 'AvE 3/18/2003 13:30'!
openFontFile: aString do: aBlock
	| face result |
	face _ self openFace: aString.
	[result := aBlock value: face ]
		ensure: [face close].
	^ result
	! !


!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/2/2002 17:31'!
ffiReturnCStringFrom: cPointer
	"Create a Smalltalk string from a zero terminated C string"
	| strLen strOop cString strPtr |
	self var: #cString declareC:'char *cString'.
	self var: #strPtr declareC:'char *strPtr'.
	cPointer = nil ifTrue:[
		^ interpreterProxy nilObject]. "nil always returs as nil"
	cString _ self cCoerce: cPointer to:'char *'.
	strLen _ 0.
	[(cString at: strLen) = 0] whileFalse:[strLen _ strLen+1].
	strOop _ interpreterProxy 
				instantiateClass: interpreterProxy classString 
				indexableSize: strLen.
	strPtr _ interpreterProxy firstIndexableField: strOop.
	0 to: strLen-1 do:[:i| strPtr at: i put: (cString at: i)].
	^strOop! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 15:57'!
fillOop: anOop withFaceMetrics: metrics
	self var: #metrics declareC:'FT_Size_Metrics  *metrics'.
	interpreterProxy  storeInteger: 0 ofObject: anOop withValue: (self cCode:'metrics->x_ppem').
	interpreterProxy  storeInteger: 1 ofObject: anOop withValue: (self cCode:'metrics->y_ppem').
	interpreterProxy  storeInteger: 2 ofObject: anOop withValue: (self cCode:'metrics->x_scale').
	interpreterProxy  storeInteger: 3 ofObject: anOop withValue: (self cCode:'metrics->y_scale').
	interpreterProxy  storeInteger: 4 ofObject: anOop withValue: (self cCode:'metrics->ascender').
	interpreterProxy  storeInteger: 5 ofObject: anOop withValue: (self cCode:'metrics->descender').
	interpreterProxy  storeInteger: 6 ofObject: anOop withValue: (self cCode:'metrics->height').
	interpreterProxy  storeInteger: 7 ofObject: anOop withValue: (self cCode:'metrics->max_advance').
! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 12:22'!
ftCharMapValueOf: oop
	"Return a pointer to the first byte of the async file record within the given Smalltalk bytes object, or nil if oop is not an async file record."

	self returnTypeC: 'FT_CharMap *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(FT_CharMap)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(FT_CharMap *) (oop + 4)'
! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 13:51'!
ftEncodingValueOf: oop
	"Return a pointer to the first byte of the async file record within the given Smalltalk bytes object, or nil if oop is not an async file record."

	self returnTypeC: 'FT_Encoding *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(FT_Encoding)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(FT_Encoding *) (oop + 4)'
! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 7/31/2002 22:30'!
ftFaceValueOf: oop
	"Return a pointer to the first byte of the async file record within the given Smalltalk bytes object, or nil if oop is not an async file record."

	self returnTypeC: 'FT_Face *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(FT_Face)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(FT_Face *) (oop + 4)'
! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/10/2002 18:58'!
ftGlyphFormatValueOf: oop
	"Return a pointer to the first byte of the async file record within the given Smalltalk bytes object, or nil if oop is not an async file record."

	self returnTypeC: 'FT_Glyph_Format *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(FT_Glyph_Format)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(FT_Glyph_Format *) (oop + 4)'
! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 16:00'!
ftGlyphSlotValueOf: oop
	"Return a pointer to the first byte of the async file record within the given Smalltalk bytes object, or nil if oop is not an async file record."

	self returnTypeC: 'FT_GlyphSlot *'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: oop) not and:
		 [(interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(FT_GlyphSlot)')]]).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(FT_GlyphSlot *) (oop + 4)'
! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 5/2/2003 12:41'!
oopFromCString: cString
	"Create a Smalltalk string from a zero terminated C string"
	| strLen strOop  strPtr |
	self var: #cString declareC:'char *cString'.
	self var: #strPtr declareC:'char *strPtr'.
	cString = nil ifTrue:[
		^ interpreterProxy nilObject]. "nil always returs as nil"
	strLen _ self  strlen: cString.
	strOop _ interpreterProxy 
				instantiateClass: interpreterProxy classString 
				indexableSize: strLen.
	strPtr _ interpreterProxy firstIndexableField: strOop.
	0 to: strLen-1 do:[:i| strPtr at: i put: (cString at: i)].
	^strOop! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 3/4/2003 15:10'!
primitiveAdvanceScanOld
	"Invoke the character scanner primitive."
	| kernDelta stops sourceString scanStopIndex scanStartIndex rcvr scanDestX scanLastIndex scanXTable scanMap maxGlyph ascii stopReason glyphIndex sourceX sourceX2 nextDestX scanRightX nilOop advanceTable hasAdvance sourcePtr |
	self var: #sourcePtr type: 'unsigned char *'.
	self methodArgumentCount = 6 ifFalse:[^self primitiveFail].
	"Load the arguments"
	kernDelta _ self stackIntegerValue: 0.
	stops _ self stackObjectValue: 1.
	(self fetchClassOf: stops) = self classArray ifFalse:[^self primitiveFail].
	(self slotSizeOf: stops) >= 258 ifFalse:[^self primitiveFail].
	scanRightX _ self stackIntegerValue: 2.
	sourceString _ self stackObjectValue: 3.
	(self isBytes: sourceString) ifFalse:[^self primitiveFail].
	scanStopIndex _ self stackIntegerValue: 4.
	scanStartIndex _ self stackIntegerValue: 5.
	(scanStartIndex > 0 and:[scanStopIndex > 0 and:[
		scanStopIndex <= (self byteSizeOf: sourceString)]])
			ifFalse:[^self primitiveFail].
	"Load receiver and required instVars"
	rcvr _ self stackObjectValue: 6.
	((self isPointers: rcvr) and:[(self slotSizeOf: rcvr) >= 21])
		ifFalse:[^self primitiveFail].
	scanDestX _ self fetchInteger: 0 ofObject: rcvr.
	scanLastIndex _ self fetchInteger: 1 ofObject: rcvr.
	scanXTable _ self fetchPointer: 2 ofObject: rcvr.
	scanMap _ self fetchPointer: 3 ofObject: rcvr.
	advanceTable _ self fetchPointer: 20 ofObject: rcvr.
	((self fetchClassOf: scanXTable) = self classArray and:[
		(self fetchClassOf: scanMap) = self classArray])
			ifFalse:[^self primitiveFail].
	hasAdvance := ((self fetchClassOf: advanceTable) = self classArray).
	(self slotSizeOf: scanMap) = 256 ifFalse:[^self primitiveFail].
	self failed ifTrue:[^nil].
	maxGlyph _ (self slotSizeOf: scanXTable) - 2.

	"Okay, here we go. We have eliminated nearly all failure conditions,
	to optimize the inner fetches."
	scanLastIndex _ scanStartIndex.
	nilOop _ self nilObject.
	sourcePtr _ interpreterProxy firstIndexableField: sourceString.
	[scanLastIndex <= scanStopIndex] whileTrue:[
		"Known to be okay since scanStartIndex > 0 and scanStopIndex <= sourceString size"
		ascii _ self byteAt: sourcePtr + scanLastIndex - 1.
		"Known to be okay since stops size >= 258"
		(stopReason _ self fetchPointer: ascii ofObject: stops) = nilOop ifFalse:[
			"Store everything back and get out of here"
			(self isIntegerValue: scanDestX) ifFalse:[^self primitiveFail].
			self storeInteger: 0 ofObject: rcvr withValue: scanDestX.
			self storeInteger: 1 ofObject: rcvr withValue: scanLastIndex.
			self pop: 7. "args+rcvr"
			^self push: stopReason].
		"Known to be okay since scanMap size = 256"
		glyphIndex _ self fetchInteger: ascii ofObject: scanMap.
		(self failed or:[glyphIndex < 0 or:[glyphIndex > maxGlyph]])
			ifTrue:[^self primitiveFail].
		sourceX _ self fetchInteger: glyphIndex ofObject: scanXTable.
		hasAdvance 
			ifTrue:[sourceX2 _ sourceX + (self fetchInteger: glyphIndex ofObject: advanceTable)] 
			ifFalse: [sourceX2 _ self fetchInteger: glyphIndex+1 ofObject: scanXTable].
		"Above may fail if non-integer entries in scanXTable"
		self failed ifTrue:[^nil].
		nextDestX _ scanDestX + sourceX2 - sourceX.
		nextDestX > scanRightX ifTrue:[
			"Store everything back and get out of here"
			(self isIntegerValue: scanDestX) ifFalse:[^self primitiveFail].
			self storeInteger: 0 ofObject: rcvr withValue: scanDestX.
			self storeInteger: 1 ofObject: rcvr withValue: scanLastIndex.
			self pop: 7. "args+rcvr"
			^self push: (self fetchPointer: 258-1 ofObject: stops)].
		scanDestX _ nextDestX + kernDelta.
		scanLastIndex _ scanLastIndex + 1].
	(self isIntegerValue: scanDestX) ifFalse:[^self primitiveFail].
	self storeInteger: 0 ofObject: rcvr withValue: scanDestX.
	self storeInteger: 1 ofObject: rcvr withValue: scanStopIndex.
	self pop: 7. "args+rcvr"
	^self push: (self fetchPointer: 257-1 ofObject: stops).! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 3/3/2003 09:08'!
primitiveCharMapInformation
		| cmPtr rcvr cmOop encOop encPtr cm |
	self var: #cmPtr declareC: 'FT_CharMap *cmPtr'.
	self var: #cm  declareC: 'FT_CharMap cm'.
	self var: #encPtr declareC: 'FT_Encoding *encPtr'.
	rcvr := self primitive: 'primitiveCharMapInformation'
		parameters: #() 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 4
		ifTrue:[^interpreterProxy primitiveFail].
	cmOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	cmPtr _ self ftCharMapValueOf: cmOop.
	cmPtr == nil ifTrue:[^interpreterProxy primitiveFail].
	cm _ self cCode:'*cmPtr'.
	cm == nil ifTrue:[^interpreterProxy primitiveFail].
	encOop _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(FT_Encoding)').
	encPtr _ self ftEncodingValueOf: encOop.
	self cCode:'*encPtr=(cm)->encoding'.
	rcvr := interpreterProxy stackValue: 0.
	interpreterProxy storePointer: 1 ofObject: rcvr 
			withValue: encOop.
	interpreterProxy storeInteger: 2 ofObject: rcvr 
			withValue: (self cCode:'(cm)->platform_id').
	interpreterProxy storeInteger: 3 ofObject: rcvr 
			withValue: (self cCode:'(cm)->encoding_id').
	
	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 7/31/2002 23:12'!
primitiveDoneFace: fh
		| face |
	self var: #face declareC: 'FT_Face *face'.
	self primitive: 'primitiveDoneFace'
		parameters: #(Oop ).
	face _ self ftFaceValueOf: fh.
	interpreterProxy failed
		ifFalse: [errorCode _ self cCode:'FT_Done_Face(*face)' 
					 inSmalltalk: 1000.]
		ifTrue: [ errorCode _ 1000.].
	interpreterProxy success: errorCode == 0.
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 7/31/2002 22:55'!
primitiveErrorCode
	self primitive: 'primitiveErrorCode'
		parameters: #().
	^ errorCode asOop: Unsigned.
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 3/3/2003 09:02'!
primitiveFaceAvaliableSizes: anArray
		| face rcvr fOop  pt  size sizes facePtr |
	self var: #facePtr declareC: 'FT_Face *facePtr'.
	self var: #face declareC: 'FT_Face face'.
	self var: #sizes declareC: 'FT_Bitmap_Size  *sizes'.
	self var: #size type:'int'.
	rcvr := self primitive: 'primitiveFaceAvailableSizes'
		parameters: #(Array) 
		receiver: #Oop.
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	facePtr _ self ftFaceValueOf: fOop.
	facePtr == nil ifTrue:[^interpreterProxy primitiveFail].
	face _ self cCode:'*facePtr'.
	face == nil ifTrue:[^interpreterProxy primitiveFail].
	sizes := self cCode: 'face->available_sizes'.
	size := (interpreterProxy slotSizeOf: anArray cPtrAsOop).
	0 to: (size -1) do:[:i| 
			pt := anArray at: i.
			interpreterProxy  storeInteger: 1 ofObject: pt withValue: (self cCode:'(sizes+i)->width').
			interpreterProxy  storeInteger: 2 ofObject: pt withValue: (self cCode:'(sizes+i)->height').]

	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 13:38'!
primitiveFaceCharMaps: anArray
		| face rcvr fOop maps  cmOop cmPtr size |
	self var: #face declareC: 'FT_Face *face'.
	self var: #maps declareC: 'FT_CharMap  *maps'.
	self var: #cmPtr declareC: 'FT_CharMap  *cmPtr'.
	self var: #size type:'int'.
	rcvr := self primitive: 'primitiveFaceCharMaps'
		parameters: #(Array) 
		receiver: #Oop.
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].
	maps := self cCode: '(*face)->charmaps'.
	size := (interpreterProxy slotSizeOf: anArray cPtrAsOop).
	0 to: (size -1) do:[:i| 
			cmOop := interpreterProxy fetchPointer:0 ofObject: (anArray at: i).
			cmPtr := self ftCharMapValueOf: cmOop.
			self cCode:'*cmPtr = maps[i]'.]

	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 3/3/2003 09:08'!
primitiveFaceInformation
		| face rcvr fOop strOop facePtr |
	self var: #face declareC: 'FT_Face face'.
	self var: #facePtr declareC: 'FT_Face *facePtr'.
	rcvr := self primitive: 'primitiveFaceInformation'
		parameters: #() 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 10
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	facePtr _ self ftFaceValueOf: fOop.
	facePtr == nil ifTrue:[^interpreterProxy primitiveFail].
	face _ self cCode:'*facePtr'.
	face == nil ifTrue:[^interpreterProxy primitiveFail].

	interpreterProxy storeInteger: 1 ofObject: rcvr 
			withValue: (self cCode:'(face)->num_faces').
	interpreterProxy storeInteger: 2 ofObject: rcvr 
			withValue: (self cCode:'(face)->face_index').
	interpreterProxy storeInteger: 3 ofObject: rcvr 
			withValue: (self cCode:'(face)->face_flags').
	interpreterProxy storeInteger: 4 ofObject: rcvr 
			withValue: (self cCode:'(face)->style_flags').
	interpreterProxy storeInteger: 5 ofObject: rcvr 
			withValue: (self cCode:'(face)->num_glyphs').
	strOop := self oopFromCString: (self cCode:'(face)->family_name').
	rcvr := interpreterProxy stackValue: 0.
	interpreterProxy storePointer: 6 ofObject: rcvr 
			withValue: strOop.
	strOop := self oopFromCString: (self cCode:'(face)->style_name').
	rcvr := interpreterProxy stackValue: 0.
	interpreterProxy storePointer: 7 ofObject: rcvr 
			withValue: strOop.
	interpreterProxy storeInteger: 8 ofObject: rcvr 
			withValue: (self cCode:'(face)->num_fixed_sizes').
	interpreterProxy storeInteger: 9 ofObject: rcvr 
			withValue: (self cCode:'(face)->num_charmaps').
	
	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 17:09'!
primitiveGetFaceCharMap: charMap
		| face rcvr fOop cmOop  cmPtr |
	self var: #face declareC: 'FT_Face *face'.
	self var: #cmPtr declareC: 'FT_CharMap  *cmPtr'.

	rcvr := self primitive: 'primitiveGetFaceCharMap'
		parameters: #(Oop) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].

	cmOop := interpreterProxy fetchPointer:0 ofObject: charMap.
	cmPtr := self ftCharMapValueOf: cmOop.
	self cCode:'*cmPtr = (*face)->charmap'

	
	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 17:09'!
primitiveGetFaceGlyphSlot: gs
		| face rcvr fOop  gsOop gsPtr |
	self var: #face declareC: 'FT_Face *face'.
	self var: #gsPtr declareC: 'FT_GlyphSlot  *gsPtr'.

	rcvr := self primitive: 'primitiveGetFaceGlyphSlot'
		parameters: #(Oop) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].

	gsOop := interpreterProxy fetchPointer:0 ofObject: gs.
	gsPtr := self ftGlyphSlotValueOf: gsOop.
	self cCode:'*gsPtr = (*face)->glyph'

	
	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 17:10'!
primitiveGetFaceSize: size
		| face rcvr fOop  |
	self var: #face declareC: 'FT_Face *face'.

	rcvr := self primitive: 'primitiveGetFaceSize'
		parameters: #(Oop) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].

	self fillOop: size withFaceMetrics: (self cCode:'&((*face)->size->metrics)').

	
	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/4/2002 16:15'!
primitiveGetScalableFaceInformation: info
		| face rcvr fOop bbox  |
	self var: #face declareC: 'FT_Face *face'.
	

	rcvr := self primitive: 'primitiveGetScalableFaceInformation'
		parameters: #(Oop) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].
	
	bbox :=  interpreterProxy fetchPointer: 0 ofObject: info.
	interpreterProxy storeInteger: 0 ofObject: bbox
			withValue: (self cCode:'(*face)->bbox.xMin').
	interpreterProxy storeInteger: 1 ofObject: bbox
			withValue: (self cCode:'(*face)->bbox.yMin').
	interpreterProxy storeInteger: 2 ofObject: bbox
			withValue: (self cCode:'(*face)->bbox.xMax').
	interpreterProxy storeInteger: 3 ofObject: bbox
			withValue: (self cCode:'(*face)->bbox.yMax').

	interpreterProxy storeInteger: 1 ofObject: info
			withValue: (self cCode:'(*face)->units_per_EM').
	interpreterProxy storeInteger: 2 ofObject: info
			withValue: (self cCode:'(*face)->ascender').
	interpreterProxy storeInteger: 3 ofObject: info
			withValue: (self cCode:'(*face)->descender').	
	interpreterProxy storeInteger: 4 ofObject: info
			withValue: (self cCode:'(*face)->height').	
	interpreterProxy storeInteger: 5 ofObject: info
			withValue: (self cCode:'(*face)->max_advance_width').	
	interpreterProxy storeInteger: 6 ofObject: info
			withValue: (self cCode:'(*face)->max_advance_height').	
	interpreterProxy storeInteger: 7 ofObject: info
			withValue: (self cCode:'(*face)->underline_position').	
	interpreterProxy storeInteger: 8 ofObject: info
			withValue: (self cCode:'(*face)->underline_thickness').	

	


	
	
	
	
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 5/2/2003 13:21'!
primitiveNewFace: pathToFontFile at: anInteger
	| face fOop sz fpath |
	self primitive: 'primitiveNewFaceAt'
		parameters: #(String Integer).
	self var: #face declareC: 'FT_Face  * face'.
	self var: #fpath declareC: 'char fpath[1024]'.
	sz _ interpreterProxy byteSizeOf: pathToFontFile cPtrAsOop.
	self cCode: 'strncpy(fpath,pathToFontFile,sz)'.
	fpath at: sz put: 0.
	fOop _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(FT_Face)').
	face _ self ftFaceValueOf: fOop.
	interpreterProxy failed
		ifFalse: [errorCode := self cCode:'FT_New_Face(library,fpath,anInteger,face)' 
					 inSmalltalk: 1000] 
		ifTrue:[errorCode := 1000].
	interpreterProxy success: errorCode == 0.
	^ fOop
	! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 3/4/2003 18:17'!
primitiveScanCharactersFrom: scanStartIndex to: scanStopIndex in: sourceString rightX: scanRightX stopConditions: stops kern: kernDelta
	"Invoke the character scanner primitive."
	| rcvr scanDestX scanLastIndex scanXTable scanMap maxGlyph ascii stopReason glyphIndex sourceX sourceX2 nextDestX nilOop advanceTable hasAdvance |
	rcvr := self primitive:'primitiveAdvanceScan'
			parameters: #(SmallInteger SmallInteger String SmallInteger Array SmallInteger)
			receiver: #Oop.
	self methodArgumentCount = 6 ifFalse:[^self primitiveFail].
	"Load the arguments"
	(interpreterProxy fetchClassOf: stops cPtrAsOop) = self classArray ifFalse:[^self primitiveFail].
	(interpreterProxy slotSizeOf: stops cPtrAsOop) >= 258 ifFalse:[^self primitiveFail].
	(scanStartIndex > 0 and:[scanStopIndex > 0 and:[
		scanStopIndex <= (self strlen: sourceString)]])
			ifFalse:[^self primitiveFail].
	"Load receiver and required instVars"
	((self isPointers: rcvr) and:[(self slotSizeOf: rcvr) >= 21])
		ifFalse:[^self primitiveFail].
	scanDestX _ self fetchInteger: 0 ofObject: rcvr.
	scanLastIndex _ self fetchInteger: 1 ofObject: rcvr.
	scanXTable _ self fetchPointer: 2 ofObject: rcvr.
	scanMap _ self fetchPointer: 3 ofObject: rcvr.
	advanceTable _ self fetchPointer: 20 ofObject: rcvr.
	((self fetchClassOf: scanXTable) = self classArray and:[
		(self fetchClassOf: scanMap) = self classArray])
			ifFalse:[^self primitiveFail].
	hasAdvance := ((self fetchClassOf: advanceTable) = self classArray).
	(self slotSizeOf: scanMap) = 256 ifFalse:[^self primitiveFail].
	self failed ifTrue:[^nil].
	maxGlyph _ (self slotSizeOf: scanXTable) - 2.

	"Okay, here we go. We have eliminated nearly all failure conditions,
	to optimize the inner fetches."
	scanLastIndex _ scanStartIndex.
	nilOop _ interpreterProxy nilObject.
	[scanLastIndex <= scanStopIndex] whileTrue:[
		"Known to be okay since scanStartIndex > 0 and scanStopIndex <= sourceString size"
		ascii _  sourceString at: (scanLastIndex - 1).
		"Known to be okay since stops size >= 258"
		(stopReason _ (stops at: ascii)) = nilOop ifFalse:[
			"Store everything back and get out of here"
			(interpreterProxy  isIntegerValue: scanDestX) ifFalse:[^self primitiveFail].
			interpreterProxy  storeInteger: 0 ofObject: rcvr withValue: scanDestX.
			interpreterProxy  storeInteger: 1 ofObject: rcvr withValue: scanLastIndex.
			^ stopReason].
		"Known to be okay since scanMap size = 256"
		glyphIndex _ self fetchInteger: ascii ofObject: scanMap.
		(self failed or:[glyphIndex < 0 or:[glyphIndex > maxGlyph]])
			ifTrue:[^self primitiveFail].
		sourceX _ self fetchInteger: glyphIndex ofObject: scanXTable.
		hasAdvance 
			ifTrue:[sourceX2 _ sourceX + (self fetchInteger: glyphIndex ofObject: advanceTable)] 
			ifFalse: [sourceX2 _ self fetchInteger: glyphIndex+1 ofObject: scanXTable].
		"Above may fail if non-integer entries in scanXTable"
		self failed ifTrue:[^nil].
		nextDestX _ scanDestX + sourceX2 - sourceX.
		nextDestX > scanRightX ifTrue:[
			"Store everything back and get out of here"
			(self isIntegerValue: scanDestX) ifFalse:[^self primitiveFail].
			self storeInteger: 0 ofObject: rcvr withValue: scanDestX.
			self storeInteger: 1 ofObject: rcvr withValue: scanLastIndex.
			
			^(stops at: 257)].
		scanDestX _ nextDestX + kernDelta.
		scanLastIndex _ scanLastIndex + 1].
	(self isIntegerValue: scanDestX) ifFalse:[^self primitiveFail].
	self storeInteger: 0 ofObject: rcvr withValue: scanDestX.
	self storeInteger: 1 ofObject: rcvr withValue: scanStopIndex.

	^(stops at: 256).! !

!FT2Plugin methodsFor: 'primitve' stamp: 'AvE 8/2/2002 14:18'!
primitiveVersion
	| rcvr major minor apatch |
	self var: #major type:'int'.
	self var: #minor type:'int'.
	self var: #apatch type:'int'.
	rcvr := self primitive: 'primitiveVersion'
		parameters: #( ) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 3
		ifTrue:[^interpreterProxy primitiveFail].
	self cCode:'FT_Library_Version(library,&major,&minor,&apatch)'.
	interpreterProxy success: errorCode == 0.
	interpreterProxy storeInteger: 0 ofObject: rcvr withValue: major.
	interpreterProxy storeInteger: 1 ofObject: rcvr withValue: minor.
	interpreterProxy storeInteger: 2 ofObject: rcvr withValue: apatch.
	
	
	
	! !

!FT2Plugin methodsFor: 'initialize' stamp: 'AvE 7/27/2002 22:47'!
initialiseModule
	|error|
	self var: #error type:'int'.
	self export: true.
	error := self cCode: 'FT_Init_FreeType(&library)' inSmalltalk:[0].
	^ error == 0.! !

!FT2Plugin methodsFor: 'interface' stamp: 'AvE 8/10/2002 21:51'!
primitiveGetBitmap: aFT2Bitmap
		| rcvr gsOop gsPtr |
	self var: #gsPtr declareC: 'FT_GlyphSlot *gsPtr'.
	rcvr := self primitive: 'primitiveGetBitmap'
		parameters: #(Oop) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 1
		ifTrue:[^interpreterProxy primitiveFail].
	(interpreterProxy slotSizeOf: aFT2Bitmap) < 6
		ifTrue:[^interpreterProxy primitiveFail].
	gsOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	gsPtr _ self ftGlyphSlotValueOf: gsOop.
	gsPtr == nil ifTrue:[^interpreterProxy primitiveFail].

	
	interpreterProxy storeInteger: 0 ofObject: aFT2Bitmap
			withValue: (self cCode:'(*gsPtr)->bitmap.rows').
	interpreterProxy storeInteger: 1 ofObject: aFT2Bitmap
			withValue: (self cCode:'(*gsPtr)->bitmap.width').
	interpreterProxy storeInteger: 2 ofObject: aFT2Bitmap
			withValue: (self cCode:'(*gsPtr)->bitmap.pitch').
	interpreterProxy storeInteger: 3 ofObject: aFT2Bitmap
			withValue: (self cCode:'(*gsPtr)->bitmap.num_grays').
	interpreterProxy storeInteger: 4 ofObject: aFT2Bitmap
			withValue: (self cCode:'(*gsPtr)->bitmap.pixel_mode').
	interpreterProxy storeInteger: 5 ofObject: aFT2Bitmap
			withValue: (self cCode:'(*gsPtr)->bitmap.palette_mode').
	
	
	! !

!FT2Plugin methodsFor: 'interface' stamp: 'AvE 3/13/2003 17:01'!
primitiveGetBitmapBuffer
		| rcvr gsOop gsPtr bmSize bmOop bmPtr nBytes j bmP gs temp |
	self var: #gsPtr declareC: 'FT_GlyphSlot *gsPtr'.
 	self var: #gs declareC: 'FT_GlyphSlot gs'.
	self var: #bmPtr declareC: 'int * bmPtr'.
	self var: #temp declareC: 'char temp'.
	rcvr := self primitive: 'primitiveGetBitmapBuffer'
		parameters: #() 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 1
		ifTrue:[^interpreterProxy primitiveFail].
	gsOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	gsPtr _ self ftGlyphSlotValueOf: gsOop.
	gsPtr == nil ifTrue:[^interpreterProxy primitiveFail].
	gs _ self cCode:'*gsPtr'.
	gs == nil ifTrue:[^interpreterProxy primitiveFail].

	nBytes := self cCode:'(gs->bitmap.rows) * abs(gs->bitmap.pitch)'.
	bmP    := self cCode:'((abs(gs->bitmap.pitch) + 4 - 1 ) /  4) /* squeak uses integers */'.
	bmSize := self cCode:'bmP * (gs->bitmap.rows)'.
	bmOop := interpreterProxy instantiateClass: interpreterProxy classBitmap indexableSize: bmSize .
	bmPtr _ bmOop asIntPtr.
	self cCode:'
if( gs->bitmap.pixel_mode == 1 ) {
        for ( i = 0, temp = 0; i < nBytes; i++, temp = 0 ) {
                        if ( gs->bitmap.buffer[i] & 0x80 )
                             temp |= 0x01;
                        if ( gs->bitmap.buffer[i] & 0x40 )
                             temp |= 0x02;
                        if ( gs->bitmap.buffer[i] & 0x20 )
                             temp |= 0x04;
                        if ( gs->bitmap.buffer[i] & 0x10 )
                             temp |= 0x08;
                        if ( gs->bitmap.buffer[i] & 0x08 )
                             temp |= 0x10;
                        if ( gs->bitmap.buffer[i] & 0x04 )
                             temp |= 0x20;
                        if ( gs->bitmap.buffer[i] & 0x02 )
                             temp |= 0x40;
                        if ( gs->bitmap.buffer[i] & 0x01 )
                             temp |= 0x80;
                        gs->bitmap.buffer[i] = temp;
        }
        }'.
	j := 0.
	0 to: nBytes - 1 by: (self cCode:'abs(gs->bitmap.pitch)') do:[
		:i |
		self cCode:'memcpy(bmPtr + j, (gs->bitmap.buffer + i), abs(gs->bitmap.pitch))'.
		j := j + bmP.].
	^ bmOop.
	
	
	! !

!FT2Plugin methodsFor: 'interface' stamp: 'AvE 8/10/2002 23:13'!
primitiveGetCharIndex: anInteger
		| face rcvr fOop  result |
	self var: #face declareC: 'FT_Face *face'.

	rcvr := self primitive: 'primitiveGetCharIndex'
		parameters: #(SmallInteger) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].

	result :=  (self cCode:'FT_Get_Char_Index((*face),anInteger)').

	^ result asOop: Unsigned.

	
	
	
	! !

!FT2Plugin methodsFor: 'interface' stamp: 'AvE 8/10/2002 23:18'!
primitiveGetNamedIndex: aString
		| face rcvr fOop  result |
	self var: #face declareC: 'FT_Face *face'.

	rcvr := self primitive: 'primitiveGetNamedIndex'
		parameters: #(String) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].

	result := (self cCode:'FT_Get_Name_Index((*face),aString)').
	^ result asOop: Unsigned.

	
	
	
	! !

!FT2Plugin methodsFor: 'interface' stamp: 'AvE 3/3/2003 09:13'!
primitiveGlyphSlotInformation
		| rcvr gsOop gsPtr oop gfOop gfPtr gs |
	self var: #gsPtr declareC: 'FT_GlyphSlot *gsPtr'.
	self var: #gs declareC: 'FT_GlyphSlot gs'.
	self var: #gfPtr declareC: 'FT_Glyph_Format *gfPtr'.
	rcvr := self primitive: 'primitiveGlyphSlotInformation'
		parameters: #() 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 7
		ifTrue:[^interpreterProxy primitiveFail].
	gsOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	gsPtr _ self ftGlyphSlotValueOf: gsOop.
	gsPtr == nil ifTrue:[^interpreterProxy primitiveFail].
	gs _ self cCode:'*gsPtr'.
	gs == nil ifTrue:[^interpreterProxy primitiveFail].


	oop := interpreterProxy positive32BitIntegerFor: (self cCode:'gs->flags').
	rcvr := interpreterProxy stackValue: 0.
	interpreterProxy storePointer: 1 ofObject: rcvr 
			withValue: oop.
	
	gfOop _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(FT_Glyph_Format)').
	gfPtr _ self ftGlyphFormatValueOf: gfOop.
	self cCode:'*gfPtr=gs->format'.
		rcvr := interpreterProxy stackValue: 0.
	interpreterProxy storePointer: 2 ofObject: rcvr 
			withValue: gfOop.
	
	interpreterProxy storeInteger: 3 ofObject: rcvr 
			withValue: (self cCode:'gs->linearHoriAdvance').
	interpreterProxy storeInteger: 4 ofObject: rcvr 
			withValue: (self cCode:'gs->linearVertAdvance').
	interpreterProxy storeInteger: 5 ofObject: rcvr 
			withValue: (self cCode:'gs->advance.x').
	interpreterProxy storeInteger: 6 ofObject: rcvr 
			withValue: (self cCode:'gs->advance.y').

	interpreterProxy storeInteger: 7 ofObject: rcvr 
			withValue: (self cCode:'gs->bitmap_left').
	interpreterProxy storeInteger: 8 ofObject: rcvr 
			withValue: (self cCode:'gs->bitmap_top').
	
	! !

!FT2Plugin methodsFor: 'interface' stamp: 'AvE 8/10/2002 19:53'!
primitiveLoadGlyph: index flags: flags
		| face rcvr fOop  |
	self var: #face declareC: 'FT_Face *face'.

	rcvr := self primitive: 'primitiveLoadGlyph'
		parameters: #(SmallInteger SmallInteger) 
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].

	errorCode := (self cCode:'FT_Load_Glyph((*face),index,flags)').
	interpreterProxy success: errorCode == 0.

	
	
	
	! !

!FT2Plugin methodsFor: 'interface' stamp: 'AvE 8/10/2002 22:08'!
primitiveSetPixelWidth: x height: y
		| face rcvr fOop  |
	self var: #face declareC: 'FT_Face *face'.

	rcvr := self primitive: 'primitiveSetPixelSizes'
		parameters: #(SmallInteger SmallInteger)
		receiver: #Oop.
	(interpreterProxy slotSizeOf: rcvr) < 11
		ifTrue:[^interpreterProxy primitiveFail].
	fOop := interpreterProxy fetchPointer: 0 ofObject: rcvr.
	face _ self ftFaceValueOf: fOop.
	face == nil ifTrue:[^interpreterProxy primitiveFail].


	errorCode := self cCode:'FT_Set_Pixel_Sizes(*face, x, y)'.
	interpreterProxy success: errorCode == 0.
	
	
	
	! !


!FT2Plugin class methodsFor: 'as yet unclassified' stamp: 'AvE 7/31/2002 22:31'!
declareCVarsIn: cg

	cg addHeaderFile: '<ft2build.h>'.
	cg addHeaderFile: 'FT_FREETYPE_H'.
	cg var: 'library' declareC:'FT_Library library'.
	cg var: 'errorCode' type:'int'.! !


!FT2ScalableFaceInfo methodsFor: 'initialize' stamp: 'AvE 8/4/2002 16:23'!
initialize
	bbox := FT2BBox new.
	! !


!FT2ScalableFaceInfo class methodsFor: 'instance creation' stamp: 'AvE 8/4/2002 14:36'!
new
	^ super new initialize.! !


!FT2SizeMetrics methodsFor: 'acccessing' stamp: 'AvE 10/17/2002 20:12'!
ppem
	^ xppem@yppem! !

!FT2SizeMetrics methodsFor: 'acccessing' stamp: 'AvE 8/22/2002 21:02'!
scaledAscender
	^ ascender // 64.! !

!FT2SizeMetrics methodsFor: 'acccessing' stamp: 'AvE 8/22/2002 21:03'!
scaledDescender
	^ descender // 64.! !

!FT2SizeMetrics methodsFor: 'acccessing' stamp: 'AvE 8/22/2002 21:03'!
scaledHeight
	^ height // 64.! !

!FT2SizeMetrics methodsFor: 'acccessing' stamp: 'AvE 8/22/2002 21:03'!
scaledMaxAdvance
	^ maxAdvance // 64.! !

!FT2SizeMetrics methodsFor: 'printing' stamp: 'AvE 10/17/2002 20:12'!
printOn: aStream
	aStream nextPutAll:'HEIGHT,ASC,DESC[';
		print: height;nextPut:$,;
		print: ascender;nextPut:$,;
		print: descender;
		nextPutAll: '],MAXADV[';
		print: maxAdvance;
		nextPutAll: '],PPEM[';
		print: self ppem;
		nextPutAll: '],SCALE[';
		print: xScale@yScale;
		nextPut: $].! !


!FT2Version methodsFor: 'as yet unclassified' stamp: 'AvE 8/2/2002 13:45'!
load
	<primitive: 'primitiveVersion' module: 'FT2Plugin'>
	^self primitiveFailed.
! !

!FT2Version methodsFor: 'as yet unclassified' stamp: 'AvE 8/2/2002 13:47'!
printOn: aStream
	aStream print: major; nextPut: $.; print: minor; nextPut:$.; print: apatch.! !

FT2Plugin removeSelector: #primitiveNewFace:!

!FT2Plugin reorganize!
('primitve' ffiReturnCStringFrom: fillOop:withFaceMetrics: ftCharMapValueOf: ftEncodingValueOf: ftFaceValueOf: ftGlyphFormatValueOf: ftGlyphSlotValueOf: oopFromCString: primitiveAdvanceScanOld primitiveCharMapInformation primitiveDoneFace: primitiveErrorCode primitiveFaceAvaliableSizes: primitiveFaceCharMaps: primitiveFaceInformation primitiveGetFaceCharMap: primitiveGetFaceGlyphSlot: primitiveGetFaceSize: primitiveGetScalableFaceInformation: primitiveNewFace:at: primitiveScanCharactersFrom:to:in:rightX:stopConditions:kern: primitiveVersion)
('initialize' initialiseModule)
('interface' primitiveGetBitmap: primitiveGetBitmapBuffer primitiveGetCharIndex: primitiveGetNamedIndex: primitiveGlyphSlotInformation primitiveLoadGlyph:flags: primitiveSetPixelWidth:height:)
!

FT2Interface removeSelector: #newFace:!

!FT2Interface reorganize!
('primives' checkFace: doneFace: errorCode fontArrayFromFile:sizes:antialiased: newFace:at: openFace: textStyleFromFile:sizes: textStyleFromFile:sizes:antialiased: version)
('font-loading' fontArrayFromFile:sizes: openFontFile:do:)
!


!FT2Face reorganize!
('initialize' initialize load setHandle:)
('as yet unclassified' antialiasedGlyphs charMaps charMaps: close glyphIndexOf: glyphIndexOfCharNamed: glyphIndexOfCharValue: glyphs glyphs: handle loadCharMap: loadFaceSize: loadGlyphAt: loadGlyphAt:flags: loadGlyphSlot: loadScalableInfo loadScalableInfo: monoGlyphs name primLoadGlyphAt:flags: setPixelWidth:height: sizeMetrics)
('converting' asFont asFontArray:antialiased: asMonoFont)
!

